<%@ page language="java" %>

<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>

<html:html>

<head>
<title>
  The Code Studio: PoolMan Struts-Based Database Client
</title>
</head>
<body bgcolor="#ffffff">

<center>
<table border="0" cellpadding="6" cellspacing="4">

<!-- BEGIN PAGE TITLE -->
<tr valign="top">
  <td>
  <font face="Helvetica,Arial" size="5" color="#000080">
  <b>PoolMan Struts-Based Database Client</b><br>
  </font>
  <font face="Helvetica,Arial" size="2" color="#808080">
  <i>PoolMan v2.1</i></font><br><br>
  <a href="poolman-struts.html"><font face="Helvetica,Arial" size="2">[JSP source]</font></a><br>
  <a href="PoolManAction.html"><font face="Helvetica,Arial" size="2">[PoolMan Struts Action class source]</font></a><br>
  <br><br>
  </td>
</tr>
<!-- END PAGE TITLE -->


<!-- BEGIN QUERY SECTION -->
<html:form name="poolmanForm" type="com.codestudio.bean.struts.PoolManActionFormBean" action="/poolman.do" focus="sql">

<tr>
  <td bgcolor="gray">
  <table cellpadding="2" cellspacing="0" width="100%">

  <logic:present name="poolmanForm" property="allDatabaseNames">
  <tr>
    <td bgcolor="lightgrey" align="center" colspan="2">
	<font face="Helvetica,Arial" size="4">
	<b>SQL Statement</b><br>
	</font>
    </td>
  </tr>

  <tr>
    <td bgcolor="lightgrey">
	<font face="Helvetica,Arial">
	<b>Use Database Pool:</b>
	</font>
    </td>

    <td bgcolor="lightgrey">
      <font face="Helvetica,Arial">
       <html:select property="currentDatabaseName">
         <html:options property="allDatabaseNames"/>
       </html:select>
      </font>
    </td>
  </tr>

  <tr>
    <td bgcolor="lightgrey">
    <font face="Helvetica,Arial">
	<b>Enter SQL:</b>
    </font>
    </td>

    <td bgcolor="lightgrey">
    <font face="Helvetica,Arial">
        <html:text property="sql" size="50"/>
    </font>
    </td>
  </tr>

  <tr>
    <td bgcolor="lightgrey"></td>
    <td bgcolor="lightgrey">
	<font face="Helvetica,Arial">
        <html:submit accesskey="x">
        Execute
        </html:submit>
        <html:reset accesskey="C">
        Clear
        </html:reset>
	</font>
    </td>
  </tr>
  </logic:present>

  <logic:notPresent name="poolmanForm" property="allDatabaseNames">
  <tr>
    <td bgcolor="lightgrey">
	<font face="Helvetica,Arial">
	<b>No databases found! Please check the location of poolman.xml.</b>
	</font>
    </td>
  </tr>
  </logic:notPresent>

  </table>

  </td>
</tr>
</html:form>
<!-- END QUERY SECTION -->


<!-- BEGIN RESULTS SECTION -->
<logic:present name="poolmanResults">

<tr valign="top">
  <td bgcolor="gray" align="center">

  <table cellpadding="10" cellspacing="0" width="100%">

    <tr valign="top">
      <td bgcolor="lightgrey" colspan="2" align="center">
	  <font face="Helvetica,Arial" size="4">
	  <b>SQL Results</b></font><p>
	  </td>
     </tr>

     <tr valign="top">

       <!-- results -->
       <td bgcolor="lightgrey">
       <font face="Helvetica,Arial">
	   <b><u>ResultSet</u></b>
	   </font><br>

       <table cellpadding="1" cellspacing="2" border="1">

       <!-- if there are errors, print them and no results -->
       <logic:present name="poolmanResults" property="error">
       <tr><td bgcolor="white">
       <font face="Helvetica,Arial" size="3" align="center">
       <br><b>A SQLException was encountered:</b><br><br>
         <bean:write name="poolmanResults" property="error"/>
       </font>
       </td></tr>
       </logic:present>

       <logic:present name="poolmanResults" property="rows">

         <!-- result set header -->
         <logic:present name="poolmanResults" property="headerColumns">
         <tr>
           <logic:iterate name="poolmanResults" property="headerColumns" id="headerCell" type="java.lang.String">
             <td bgcolor="white"><font face="Helvetica,Arial" size="3" align="center"><b>
             <bean:write name="headerCell"/>
             </b></font></td>
           </logic:iterate>
         </tr>
         </logic:present>

         <!-- result set rows -->
         <logic:iterate name="poolmanResults" property="rows" id="rows" type="java.util.ArrayList">
           <tr>
           <logic:iterate name="rows" id="rowCell" type="java.lang.Object">
             <td bgcolor="white"><font face="Helvetica,Arial" size="3">
             <bean:write name="rowCell"/>
             </font></td>
           </logic:iterate>
           </tr>
         </logic:iterate>

       </logic:present>

       </table>

       </td>

       <!-- metrics -->
       <td bgcolor="lightgrey">
       <font face="Helvetica,Arial">

	   <b><u>PoolMan Info</u></b><br>

       Number of queries this session: <bean:write name="poolmanMetrics" property="queryCount"/><br>
       Last statement: <bean:write name="poolmanForm" property="sql"/><br>
       Current database pool: <bean:write name="poolmanForm" property="currentDatabaseName"/><br>
       Using cache: <bean:write name="poolmanMetrics" property="usingCache"/><br>
       DB URL: <bean:write name="poolmanMetrics" property="url"/><br>
       DB Driver: <bean:write name="poolmanMetrics" property="dbDriver"/><br>
       DB User: <bean:write name="poolmanMetrics" property="user"/><br>

       <br><br>
       <b><u>PoolMan Metrics</u></b><br>

       Total connections in this pool: <bean:write name="poolmanMetrics" property="totalConnections"/><br>
       Available connections: <bean:write name="poolmanMetrics" property="availableConnections"/><br>
       Unavailable connections: <bean:write name="poolmanMetrics" property="unavailableConnections"/><br>
       Last query execution time: <bean:write name="poolmanMetrics" property="lastQueryDuration"/> millis<br>

       </font>
       </td>

     </tr>

   </table>
   </td>
</tr>

</logic:present>
<!-- END RESULTS SECTION -->


</table>
</center>
</body>

</html:html>
