package poolman.tests.util;

import junit.framework.*;
import poolman.tests.*;

import java.util.*;
import com.codestudio.util.*;


/**
 * This suite of tests covers deprecated SQLUtil usage.
 */
public class SQLUtilTests extends TestCase {

    public SQLUtilTests(String name) {
	super(name);
    }

    public static Test suite() {
	return new TestSuite(SQLUtilTests.class);
    }
    
    public void testSelect() {
	try {
	    String sql = "select * from neville";
	    SQLResult result = SQLUtil.getInstance().execute("testdb", sql);
	    //if (result.size() == 0)
		 // System.out.println("\tEmpty results");
	    
	    while (result.hasNext()) {
		Hashtable row = result.next();
		// in this "row", all keys are columns and all values are data
		for (Enumeration enum=row.keys(); enum.hasMoreElements(); ) {
		    String column_name = enum.nextElement().toString();
		    String data_field = row.get(column_name).toString();
		    //System.out.print("\t" + column_name + ": " + data_field);
		}
		//System.out.print("\n");
	    }
	} catch (Exception e) {
	    e.printStackTrace();
	    fail(e.toString());
	}
    }
    
}

