/*
 *  PoolMan Java Object Pooling and Caching Library
 *  Copyright (C) 1999-2001 The Code Studio
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  The full license is located at the root of this distribution
 *  in the LICENSE file.
 */
package com.codestudio.bean.struts;

import java.io.Serializable;
import java.util.ArrayList;

public class PoolManResultsBean
        implements Serializable {

    protected ArrayList headerColumns;
    protected ArrayList rows;
    protected String error;

    public PoolManResultsBean() {
    }

    public ArrayList getHeaderColumns() {
        return headerColumns;
    }

    public void setHeaderColumns(ArrayList header) {
        headerColumns = header;
    }

    public ArrayList getRows() {
        return rows;
    }

    public void setRows(ArrayList rows) {
        this.rows = rows;
    }

    public String getError() {
        return error;
    }

    public void setError(String error) {
        this.error = error;
    }

    public void addRow(ArrayList row) {
        if (rows == null)
            rows = new ArrayList();
        rows.add(row);
    }

}
