package poolman.tests.basic;

import junit.framework.*;
import poolman.tests.*;

import java.lang.StringBuffer;

import com.codestudio.management.*;
import com.codestudio.util.*;


/**
 * This suite of tests covers generic object pooling.
 */
public class GenericPoolTests extends TestCase {

    private GenericPoolManager manager;

 
    public GenericPoolTests(String name) {
	super(name);
    }

    public static Test suite() {
	return new TestSuite(GenericPoolTests.class);
    }
    
    protected void setUp() {
	this.manager = GenericPoolManager.getInstance();
    }
    
    public void testGenericPool() {
	try {
	    StringBuffer sb = (StringBuffer) manager.requestObject("mypool");
	    sb.append("test");
	    System.out.println(sb.toString());
	    manager.returnObject(sb);
	} catch (Exception e) {
        System.out.println(e + "\n\n");
	    e.printStackTrace();
	    fail(e.toString());
	}
    }
    
}

